﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinGrid_HotTracking_Column_CS
{
    public partial class Form1 : Form
    {
        private DataTable dt1;
        private UltraGridColumn hotTrackedColumn;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(100);

            dt1.TableName = "Band 0";

            dt1.AcceptChanges();
            this.ultraGrid1.DataSource = dt1;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var ov = layout.Override;

            //ov.HotTrackRowAppearance.BackColor = SystemColors.Highlight;
            //ov.HotTrackRowAppearance.ForeColor = SystemColors.HighlightText;

            var hotTrackColumnAppearance = layout.Appearances.Add("HotTrackColumn");
            hotTrackColumnAppearance.BackColor = SystemColors.Highlight;
            hotTrackColumnAppearance.ForeColor = SystemColors.HighlightText;
        }

        private UltraGridColumn HotTrackedColumn
        {
            get { return this.hotTrackedColumn;  }
            set
            {
                if (this.hotTrackedColumn == value)
                    return;

                if (this.hotTrackedColumn != null)
                    this.hotTrackedColumn.ResetCellAppearance();

                this.hotTrackedColumn = value;

                if (this.hotTrackedColumn != null)
                    this.hotTrackedColumn.CellAppearance = this.ultraGrid1.DisplayLayout.Appearances["HotTrackColumn"];
            }
        }

        private void ultraGrid1_MouseMove(object sender, MouseEventArgs e)
        {
            var grid = (UltraGridBase)sender;
            var gridElement = grid.DisplayLayout.UIElement;

            var targetElement = gridElement.ElementFromPoint(e.Location);
            if (null == targetElement)
            {
                this.HotTrackedColumn = null;
                return;

            }
            var cellUIElement = targetElement as CellUIElement;
            
            if (null == cellUIElement)
                cellUIElement = targetElement.GetAncestor(typeof(CellUIElement)) as CellUIElement;

            if (null == cellUIElement)
                this.HotTrackedColumn = null;
            else
            {
                var cell = cellUIElement.GetContext(typeof(UltraGridCell)) as UltraGridCell;
                if (null != cell)
                    this.HotTrackedColumn = cell.Column;
                else
                    this.HotTrackedColumn = null;
            }
        }
    }
}
